Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 4901)
+++ palm/trunk/SOURCE/modules.f90	(revision 1)
@@ -1630,89 +1209,66 @@
  END MODULE profil_parameter
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of statistical quantities, e.g. global sums.
-!--------------------------------------------------------------------------------------------------!
+
+
+
+ MODULE spectrum
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of quantities used for computing spectra
+!------------------------------------------------------------------------------!
+
+    CHARACTER (LEN=6),  DIMENSION(1:5) ::  header_char = (/ 'PS(u) ', 'PS(v) ',&
+                                           'PS(w) ', 'PS(pt)', 'PS(q) ' /)
+    CHARACTER (LEN=2),  DIMENSION(10)  ::  spectra_direction = 'x'
+    CHARACTER (LEN=10), DIMENSION(10)  ::  data_output_sp  = ' '
+    CHARACTER (LEN=25), DIMENSION(1:5) ::  utext_char =                    &
+                                           (/ '-power spectrum of u     ', &
+                                              '-power spectrum of v     ', &
+                                              '-power spectrum of w     ', &
+                                              '-power spectrum of ^1185 ', &
+                                              '-power spectrum of q     ' /)
+    CHARACTER (LEN=39), DIMENSION(1:5) ::  ytext_char =                        &
+                                 (/ 'k ^2236 ^2566^2569<u(k) in m>2s>->2    ', &
+                                    'k ^2236 ^2566^2569<v(k) in m>2s>->2    ', &
+                                    'k ^2236 ^2566^2569<w(k) in m>2s>->2    ', &
+                                    'k ^2236 ^2566^2569<^1185(k) in m>2s>->2', &
+                                    'k ^2236 ^2566^2569<q(k) in m>2s>->2    ' /)
+
+    INTEGER ::  klist_x = 0, klist_y = 0, n_sp_x = 0, n_sp_y = 0
+
+    INTEGER ::  comp_spectra_level(10) = 999999,                   &
+                lstyles(10) = (/ 0, 7, 3, 10, 1, 4, 9, 2, 6, 8 /), &
+                plot_spectra_level(10) = 999999
+
+    REAL    ::  time_to_start_sp = 0.0
+
+    SAVE
+
+ END MODULE spectrum
+
+
+
+
  MODULE statistics
 
-    USE kinds
-
-    CHARACTER (LEN=40) ::  region(0:9) = 'total domain                            '  !< label for statistic region
-
-    INTEGER(iwp) ::  pr_palm = 200          !< maximum number of output profiles
-    INTEGER(iwp) ::  statistic_regions = 0  !< identifier for statistic regions
-
-    INTEGER(iwp) ::  u_max_ijk(3) = -1  !< index values (i,j,k) of location where u_max occurs
-    INTEGER(iwp) ::  v_max_ijk(3) = -1  !< index values (i,j,k) of location where v_max occurs
-    INTEGER(iwp) ::  w_max_ijk(3) = -1  !< index values (i,j,k) of location where w_max occurs
-
-    LOGICAL ::  flow_statistics_called = .FALSE.  !< flag that tells other routines if flow statistics was executed
-                                                  !< (after each timestep)
-
-    REAL(wp) ::  u_max = 0.0_wp  !< maximum of absolute u-veloctiy in entire domain
-    REAL(wp) ::  v_max = 0.0_wp  !< maximum of absolute v-veloctiy in entire domain
-    REAL(wp) ::  w_max = 0.0_wp  !< maximum of absolute w-veloctiy in entire domain
-
-    REAL(wp), DIMENSION(2) ::  z_i  !< inversion height
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  mean_surface_level_height  !< mean surface level height for the different statistic
-                                                                       !< regions
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  sums_divnew_l              !< subdomain sum (_l) of divergence after pressure
-                                                                       !< solver call (new)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  sums_divold_l              !< subdomain sum (_l) of divergence before pressure
-                                                                       !< solver call (old)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  weight_pres                !< substep weighting factor for pressure solver
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  weight_substep             !< weighting factor for substeps in timestepping
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums             !< global sum array for the various output quantities
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_ls_l        !< subdomain sum of large scale forcing and nudging tendencies
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_salsa_ws_l  !< subdomain sum of vertical salsa flux w's'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_us2_ws_l    !< subdomain sum of horizontal momentum flux u'u'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_vs2_ws_l    !< subdomain sum of horizontal momentum flux v'v'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_ws2_ws_l    !< subdomain sum of vertical momentum flux w'w'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsncs_ws_l  !< subdomain sum of vertical clouddrop-number concentration flux
-                                                               !< w'nc' (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsngs_ws_l  !< subdomain sum of vertical graupel-number concentration flux w'nc' (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsnis_ws_l  !< subdomain sum of vertical ice crystal concentration flux w'ni'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsnrs_ws_l  !< subdomain sum of vertical raindrop-number concentration flux w'nr'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsnss_ws_l  !< subdomain sum of vertical snow-number concentration flux w'ns' (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wssas_ws_l  !< subdomain sum of vertical salinity flux w'sa'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsss_ws_l   !< subdomain sum of vertical passive scalar flux w's'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wspts_ws_l  !< subdomain sum of vertical sensible heat flux w'pt'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqcs_ws_l  !< subdomain sum of vertical cloudwater flux w'qc'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqgs_ws_l  !< subdomain sum of vertical graupel flux w'qg' (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqis_ws_l  !< subdomain sum of vertical ice crystal flux w'qi'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqrs_ws_l  !< subdomain sum of vertical rainwater flux w'qr'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqss_ws_l  !< subdomain sum of vertical snow flux w'qs' (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsqs_ws_l   !< subdomain sum of vertical latent heat flux w'q'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsts_bc_l   !< subdomain sum of sensible heat flux in Bott-Chlond scheme
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsus_ws_l   !< subdomain sum of vertical momentum flux w'u'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sums_wsvs_ws_l   !< subdomain sum of vertical momentum flux w'v'
-                                                               !< (5th-order advection scheme only)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ts_value         !< timeseries output array for the various output quantities
-
-    REAL(wp), DIMENSION(:,:), POINTER     ::  sums_wschs_ws_l  !< subdomain sum of vertical chemistry flux w'ch'
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  hom_sum             !< sum array for horizontal mean
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rmask               !< REAL flag array (0.0 or 1.0) for statistic regions
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  sums_l              !< subdomain sum (_l) gathered for various quantities
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  sums_l_l            !< subdomain sum (_l) of mixing length from diffusivities
-
-    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  hom  !< horizontal mean of various quantities (profiles/timeseries)
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of statistical quantities, e.g. global sums
+!------------------------------------------------------------------------------!
+
+    CHARACTER (LEN=40) ::  region(0:9)
+    INTEGER ::  statistic_regions = 0, var_hom = 80, var_sum = 80
+    INTEGER ::  u_max_ijk(3), v_max_ijk(3), w_max_ijk(3)
+    LOGICAL ::  flow_statistics_called = .FALSE.
+    REAL ::     u_max, v_max, w_max
+    REAL, DIMENSION(:), ALLOCATABLE       ::  sums_divnew_l, sums_divold_l
+    REAL, DIMENSION(:,:), ALLOCATABLE     ::  sums, sums_wsts_bc_l
+    REAL, DIMENSION(:,:,:), ALLOCATABLE   ::  hom_sum, rmask, spectrum_x, &
+                                              spectrum_y, sums_l, sums_l_l, &
+                                              sums_up_fraction_l
+    REAL, DIMENSION(:,:,:,:), ALLOCATABLE ::  hom
 
     SAVE
@@ -1722,29 +1278,17 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of indices for transposed arrays.
-!--------------------------------------------------------------------------------------------------!
+
  MODULE transpose_indices
 
-    USE kinds
-
-    INTEGER(iwp) ::  nxl_y   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nxl_yd  !< internal index bound for transpositions
-    INTEGER(iwp) ::  nxl_z   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nxr_y   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nxr_yd  !< internal index bound for transpositions
-    INTEGER(iwp) ::  nxr_z   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nyn_x   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nyn_z   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nys_x   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nys_z   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nzb_x   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nzb_y   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nzb_yd  !< internal index bound for transpositions
-    INTEGER(iwp) ::  nzt_x   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nzt_y   !< internal index bound for transpositions
-    INTEGER(iwp) ::  nzt_yd  !< internal index bound for transpositions
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of indices for transposed arrays
+!------------------------------------------------------------------------------!
+
+    INTEGER ::  nxl_y, nxl_yd, nxl_z, nxr_y, nxr_ya, nxr_yd, nxr_yda, nxr_z, &
+                nxr_za, nyn_x, nyn_xa, nyn_z, nyn_za, nys_x, nys_z, nzb_x,   &
+                nzb_y, nzb_yd, nzt_x, nzt_xa, nzt_y, nzt_ya, nzt_yd, nzt_yda
+                
 
     SAVE
Index: palm/trunk/SOURCE/package_parin.f90
===================================================================
--- palm/trunk/SOURCE/package_parin.f90	(revision 1)
+++ palm/trunk/SOURCE/package_parin.f90	(revision 1)
@@ -0,0 +1,173 @@
+ SUBROUTINE package_parin
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: package_parin.f90,v $
+! Revision 1.18  2006/08/04 14:52:23  raasch
+! +dt_dopts, dt_min_part, end_time_prel, particles_per_point,
+! use_sgs_for_particles in particles_par
+!
+! Revision 1.17  2006/04/11 14:59:05  raasch
+! pl_spectra renamed data_output_sp
+!
+! Revision 1.16  2006/02/23 12:43:24  raasch
+! +number_of_particle_groups, skip_particles_for_tail, use_particle_tails in
+! particles_par,
+! +skip_time_dosp in spectra_par,
+! dt_plsp renamed dt_dosp, default setting of dt_dops,
+! set flag particle_advection
+!
+! Revision 1.15  2005/06/26 20:05:42  raasch
+! diameter renamed radius
+!
+! Revision 1.14  2003/10/29 09:01:29  raasch
+! +diameter in particles_par, uniform_psize renamed dvrp_psize
+!
+! Revision 1.13  2003/08/01 08:43:33  raasch
+! +slicer_range_limits_dvrp in dvrp_graphics_par
+!
+! Revision 1.12  2003/03/16 09:42:11  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.11  2002/09/12 13:06:50  raasch
+! +density_ratio in particles_par
+!
+! Revision 1.10  2002/04/16 08:10:08  raasch
+! +variables for particle boundary conditions, +vertical_particle_advection
+! in particles_par
+!
+! Revision 1.9  2001/11/12 16:07:04  raasch
+! +read_particles_from_restartfile
+!
+! Revision 1.7  2001/08/21 09:52:55  raasch
+! +superelevation, superelevation_x, superelevation_y in dvrp_graphics_par,
+! +maximum_number_of_particles, maximum_number_of_tailpoints,
+! maximum_tailpoint_age, minimum_tailpoint_distance in particles_par
+!
+! Revision 1.6  2001/07/12 12:42:49  raasch
+! +several new parameters in dvrp_graphics_par and particles_par
+!
+! Revision 1.5  2001/03/30 07:37:56  raasch
+! Namelist names changed,
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.4  2001/01/25 07:10:48  raasch
+! +write_particle_informations
+!
+! Revision 1.2  2001/01/05 15:13:34  raasch
+! Spectra package added
+!
+! Revision 1.1  2000/12/28 13:21:57  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! This subroutine reads from the NAMELIST file variables controling model
+! software packages which are used optionally in the run.
+!------------------------------------------------------------------------------!
+
+    USE control_parameters
+    USE dvrp_variables
+    USE particle_attributes
+    USE spectrum
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=80) ::  zeile
+
+    NAMELIST /dvrp_graphics_par/  dt_dvrp, dvrp_directory, dvrp_file,          &
+                                  dvrp_host, dvrp_output, dvrp_password,       &
+                                  dvrp_username, mode_dvrp,                    &
+                                  slicer_range_limits_dvrp, superelevation,    &
+                                  superelevation_x, superelevation_y, threshold
+    NAMELIST /particles_par/      bc_par_b, bc_par_lr, bc_par_ns, bc_par_t,    &
+                                  density_ratio, radius, dt_dopts,             &
+                                  dt_min_part, dt_prel,                        &
+                                  dt_write_particle_data, dvrp_psize,          &
+                                  end_time_prel, initial_weighting_factor,     &
+                                  maximum_number_of_particles,                 &
+                                  maximum_number_of_tailpoints,                &
+                                  maximum_tailpoint_age,                       &
+                                  minimum_tailpoint_distance,                  &
+                                  number_of_particle_groups,                   &
+                                  particles_per_point,                         &
+                                  particle_advection_start,                    &
+                                  particle_maximum_age, pdx, pdy, pdz, psb,    &
+                                  psl, psn, psr, pss, pst,                     &
+                                  random_start_position,                       &
+                                  read_particles_from_restartfile,             &
+                                  skip_particles_for_tail, use_particle_tails, &
+                                  use_sgs_for_particles,                       &
+                                  vertical_particle_advection,                 &
+                                  write_particle_statistics
+    NAMELIST /spectra_par/        averaging_interval_sp, comp_spectra_level,   &
+                                  data_output_sp, dt_dosp, plot_spectra_level, &
+                                  skip_time_dosp, spectra_direction
+
+!
+!-- Position the namelist-file at the beginning (it was already opened in
+!-- parin), search for the namelist-group of the package and position the
+!-- file at this line. Do the same for each optionally used package.
+    zeile = ' '
+
+#if defined( __dvrp_graphics )
+    REWIND ( 11 )
+    zeile = ' '
+    DO   WHILE ( INDEX( zeile, '&dvrp_graphics_par' ) == 0 )
+       READ ( 11, '(A)', END=10 )  zeile
+    ENDDO
+    BACKSPACE ( 11 )
+
+!
+!-- Read user-defined namelist
+    READ ( 11, dvrp_graphics_par )
+
+ 10 CONTINUE
+#endif
+
+#if defined( __particles )
+    REWIND ( 11 )
+    zeile = ' '
+    DO   WHILE ( INDEX( zeile, '&particles_par' ) == 0 )
+       READ ( 11, '(A)', END=20 )  zeile
+    ENDDO
+    BACKSPACE ( 11 )
+
+!
+!-- Read user-defined namelist
+    READ ( 11, particles_par )
+
+!
+!-- Set flag that indicates that particles are switched on
+    particle_advection = .TRUE.
+
+ 20 CONTINUE
+#endif
+
+#if defined( __spectra )
+    REWIND ( 11 )
+    zeile = ' '
+    DO   WHILE ( INDEX( zeile, '&spectra_par' ) == 0 )
+       READ ( 11, '(A)', END=30 )  zeile
+    ENDDO
+    BACKSPACE ( 11 )
+
+!
+!-- Read user-defined namelist
+    READ ( 11, spectra_par )
+
+!
+!-- Default setting of dt_dosp here (instead of check_parameters), because its
+!-- current value is needed in init_pegrid
+    IF ( dt_dosp == 9999999.9 )  dt_dosp = dt_data_output
+
+ 30 CONTINUE
+#endif
+
+ END SUBROUTINE package_parin
